package com.ouling.weibo;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;
import com.ouling.weibo.OAuth.OAuthConstant;
import com.ouling.weibo.basic.Weibo;
import com.ouling.weibo.basic.WeiboException;

//ʾתʾ

public class CommentMentionDialog {

	private CheckBox checkBox;
	private EditText editText;

	public CommentMentionDialog(final Context context, final boolean isComment,
			final long weiboID, final String cid) {

		LayoutInflater inflater = ((Activity) context).getLayoutInflater();
		View layout = inflater.inflate(R.layout.dialog, null);

		new AlertDialog.Builder(context)
				.setView(layout)
				.setPositiveButton("ȷ", new DialogInterface.OnClickListener() {

					@Override
					public void onClick(DialogInterface dialog, int which) {
						try {
							Weibo weibo = OAuthConstant.getInstance().getWeibo();
							String text = editText.getText().toString();
							String msg = "";
							if (TextUtils.isEmpty(text)) {
								Toast.makeText(context, "˵ʲô",
										Toast.LENGTH_LONG).show();
								return;
							}
							if (text.length() > 140) {
								Toast.makeText(context, "Ҫ۵̫",
										Toast.LENGTH_LONG).show();
								return;
							}
							if (isComment) {
								weibo.updateComment(text, weiboID + "", cid);
								msg = "۳ɹ";
								if (checkBox.isChecked()) {
									weibo.updateStatus(text, weiboID);
									msg = "תɹ";
								}
							} else {
								weibo.updateStatus(text, weiboID);
								msg = "תɹ";
								if (checkBox.isChecked()) {
									weibo.updateComment(text, weiboID + "", cid);
									msg = "תɹ";
								}
							}
							Toast.makeText(context, msg, Toast.LENGTH_LONG)
									.show();
						} catch (WeiboException e) {
							e.printStackTrace();
							Toast.makeText(context, "ۻתʧ",
									Toast.LENGTH_LONG).show();
						}
					}
				})
				.setNegativeButton("ȡ", new DialogInterface.OnClickListener() {

					@Override
					public void onClick(DialogInterface dialog, int which) {
					}
				}).setTitle(isComment ? "΢" : "ת΢").show();

		checkBox = (CheckBox) layout.findViewById(R.id.dialog_cb);
		editText = (EditText) layout.findViewById(R.id.dialog_et);
	}
}
