package com.ouling.weibo.util;

import android.content.Context;
import android.content.res.TypedArray;
import android.util.AttributeSet;
import android.view.MotionEvent;
import com.ouling.weibo.R;
import com.ouling.weibo.util.AsyncImageView;

class MyImageView extends AsyncImageView {

	public MyImageView(Context context) {
		super(context);
	}

	public MyImageView(Context context, AttributeSet attrs) {
		super(context, attrs);
		TypedArray a = context.obtainStyledAttributes(attrs,
				R.styleable.oulingxmlns);

		gifNeeded = a.getBoolean(R.styleable.oulingxmlns_gif, false);
	}

	// ImageViewλ
	private void setLocation(int x, int y) {
		int left = this.getLeft() + x;
		int right = this.getRight() + x;
		int top = this.getTop() + y;
		int bottom = this.getBottom() + y;

		// ͼƬĸܳĻ
		float bm_left = left + (MyView.screenWidth - MyView.bitmap_width) / 2
				* (right - left) / MyView.screenWidth;
		float bm_right = right - (MyView.screenWidth - MyView.bitmap_width) / 2
				* (right - left) / MyView.screenWidth;
		float bm_top = top + (MyView.screenHeight - MyView.bitmap_height) / 2
				* (bottom - top) / MyView.screenHeight;
		float bm_bottom = bottom - (MyView.screenHeight - MyView.bitmap_height)
				/ 2 * (bottom - top) / MyView.screenHeight;
		if (bm_left > MyView.screenWidth / 2
				|| bm_right < MyView.screenWidth / 2) {
			left = this.getLeft();
			right = this.getRight();
		}
		if (bm_top > MyView.screenHeight / 2
				|| bm_bottom < MyView.screenHeight / 2) {
			top = this.getTop();
			bottom = this.getBottom();
		}
		this.setFrame(left, top, right, bottom);
	}

	/*
	 * ŴСImageView
	 * 
	 * ΪͼƬImageViewģҲзŴСͼƬЧ
	 */
	protected boolean setScale(float temp) {
		int left = this.getLeft() - (int) (temp);
		int right = this.getRight() + (int) (temp);
		int top = this.getTop() - (int) (temp);
		int bottom = this.getBottom() + (int) (temp);

		// źĴСĻСԶųӦĻСĳߴ
		if (right - left < MyView.bitmap_width / 5
				|| bottom - top < MyView.bitmap_height / 5) {
			this.setFrame(MyView.init_left, MyView.init_top, MyView.init_right,
					MyView.init_bottom);
			return false;
		}

//		// ܳԭʼͼص25
//		if (right - left > bitmap.getWidth() * 5
//				|| bottom - top > bitmap.getHeight() * 5) {
//			return false;
//		}

		this.setFrame(left, top, right, bottom);
		return true;
	}

	/*
	 * ͼƬָλƶ beforeXYǰһλõ afterXY浱ǰλõ
	 * ǵĲֵImageViewӻֵ
	 */
	public void moveWithFinger(MotionEvent event) {

		switch (event.getAction()) {

			case MotionEvent.ACTION_DOWN:
				MyView.beforeX = event.getX();
				MyView.beforeY = event.getY();
				break;

			case MotionEvent.ACTION_MOVE:
				MyView.afterX = event.getX();
				MyView.afterY = event.getY();

				this.setLocation((int) (MyView.afterX - MyView.beforeX),
						(int) (MyView.afterY - MyView.beforeY));

				MyView.beforeX = MyView.afterX;
				MyView.beforeY = MyView.afterY;
				break;

			case MotionEvent.ACTION_UP:
				break;
		}
	}

	/*
	 * ͨ㴥ŴСͼ beforeLenghtǰһʱ֮ľ afterLenght浱ǰʱ֮ľ
	 */
	public void scaleWithFinger(MotionEvent event) {
		float moveX = event.getX(1) - event.getX(0);
		float moveY = event.getY(1) - event.getY(0);

		switch (event.getAction()) {
			case MotionEvent.ACTION_POINTER_DOWN:
				MyView.beforeLenght = (float) Math.sqrt((moveX * moveX)
						+ (moveY * moveY));
				break;
			case MotionEvent.ACTION_MOVE:
				// õ֮ĳ
				MyView.afterLenght = (float) Math.sqrt((moveX * moveX)
						+ (moveY * moveY));
				if (!MyView.point_first) {
					float scaled = MyView.afterLenght - MyView.beforeLenght;

					if (scaled == 0)
						break;

					// if (scaled > 0) {
					this.setScale(scaled);
					// } else {
					// this.setScale(scaled / 2, 1);
					// }
				}
				MyView.point_first = false;
				MyView.beforeLenght = MyView.afterLenght;
				break;
		}
	}

}